void text_packet_send(unsigned char *packet)
{
   unsigned short i;
   unsigned long sum;
   TEXT_PACKET *text_packet;
   unsigned char header[12];
   PSEUDO_HEADER *pseudo_header;
   
   text_packet = (TEXT_PACKET *)packet; /* packetTEXT_PACKET\̂ɓĂ͂߂ */
   
   for (i = 0; i < 6; i++)
   {
      text_packet -> eth_dst_MAC[i] = dst_MAC[i]; /* MACAhX */
   }
   for (i = 0; i < 6; i++)
   {
      text_packet -> eth_src_MAC[i] = src_MAC[i]; /* MMACAhX */
   }
   text_packet -> eth_ethernet_type = 0x0800; /* ʃvgR̎ށiIPj */
   text_packet -> ip_version_length = 0x45; /* IP̃o[WIPwb_̒ */
   text_packet -> ip_service_type = 0; /* pPbg̗Dx */
   text_packet -> ip_total_length = 20 + 8 + 16; /* IPf[^O̒ */
   text_packet -> ip_id = src_ip_id; /* pPbg̎ʎq */
   text_packet -> ip_flags_fragment_offset = 0x4000; /* pPbg̗̕LƖ{̃f[^ʒu */
   text_packet -> ip_time_to_live = 128; /* [^̒p񐔂̏ */
   text_packet -> ip_protocol = 17; /* ʃvgR̎ށiUDPj */
   text_packet -> ip_checksum = 0x0000; /* `FbNT̏l */
   for (i = 0; i < 4; i++)
   {
      text_packet -> ip_src_IP[i] = src_IP[i]; /* MIPAhX */
   }
   for (i = 0; i < 4; i++)
   {
      text_packet -> ip_dst_IP[i] = dst_IP[i]; /* IPAhX */
   }
   text_packet -> udp_src_port = src_port; /* M|[gԍ */
   text_packet -> udp_dst_port = dst_port; /* |[gԍ */
   text_packet -> udp_length = 8 + 16; /* UDPZOg̒ */
   text_packet -> udp_checksum = 0x0000; /* `FbNT̏l */
   for (i = 0; i < 16; i++)
   {
      text_packet -> text_data[i] = text_buffer[i];
      /* text_bufferɊi[ꂽeLXgEf[^pPbgɓڂ */
   }
   
   /* MɂIPwb_̃`FbNŤvZ */
   sum = ones_complement_sum(packet, 14, 20); /* 1̕␔aiIPwb_j */
   sum = (~sum) & 0xFFFF; /* vZʂNOTZɂĔ] */
   text_packet -> ip_checksum = (unsigned short)sum; /* vZʂZbg */
   
   /* [wb_ */
   pseudo_header = (PSEUDO_HEADER *)header; /* headerPSEUDO_HEADER\̂ɓĂ͂߂ */
   for (i = 0; i < 4; i++)
   {
      pseudo_header -> ip_src_IP[i] = text_packet -> ip_src_IP[i]; /* MIPAhX */
      pseudo_header -> ip_dst_IP[i] = text_packet -> ip_dst_IP[i]; /* IPAhX */
   }
   pseudo_header -> zero_padding = 0; /* [EpfBO */
   pseudo_header -> ip_protocol = text_packet -> ip_protocol; /* ʃvgR̎ށiUDPj */
   pseudo_header -> udp_length = text_packet -> udp_length; /* UDPZOg̒ */
   
   /* MɂUDPwb_̃`FbNŤvZ */
   sum = ones_complement_sum(header, 0, 12); /* 1̕␔ai[wb_j */
   sum += ones_complement_sum(packet, 34, (8 + 16)); /* 1̕␔aiUDPZOgj */
   sum = (sum & 0xFFFF) + (sum >> 16); /* 1̕␔a */
   sum = (~sum) & 0xFFFF; /* vZʂNOTZɂĔ] */
   if (sum == 0x0000)
   {
      sum = 0xFFFF; /* vZʂ0x0000ƂȂĂ܂ꍇ0xFFFFɂ */
   }
   text_packet -> udp_checksum = (unsigned short)sum; /* vZʂZbg */
   
   packet_send(packet, 60); /* pPbg̃TCY60byteɎw肵đM */
}

unsigned char text_packet_error_check(unsigned char *packet)
{
   unsigned short i;
   unsigned long sum;
   TEXT_PACKET *text_packet;
   unsigned char header[12];
   PSEUDO_HEADER *pseudo_header;
   
   text_packet = (TEXT_PACKET *)packet; /* packetTEXT_PACKET\̂ɓĂ͂߂ */
   
   /* MɂIPwb_̃`FbNŤvZ */
   sum = ones_complement_sum(packet, 14, 20); /* 1̕␔aiIPwb_j */
   sum = (~sum) & 0xFFFF; /* vZʂNOTZɂĔ] */
   if (sum != 0x0000)
   {
      return 1; /* `FbNT0x0000ɂȂȂꍇ̓G[Ƃ݂Ȃ */
   }
   
   if (text_packet -> udp_checksum != 0x0000) /* UDPwb_̃`FbNT0x0000ł͂ȂƂ */
   {
      /* [wb_ */
      pseudo_header = (PSEUDO_HEADER *)header; /* headerPSEUDO_HEADER\̂ɓĂ͂߂ */
      for (i = 0; i < 4; i++)
      {
         pseudo_header -> ip_src_IP[i] = text_packet -> ip_src_IP[i]; /* MIPAhX */
         pseudo_header -> ip_dst_IP[i] = text_packet -> ip_dst_IP[i]; /* IPAhX */
      }
      pseudo_header -> zero_padding = 0; /* [EpfBO */
      pseudo_header -> ip_protocol = text_packet -> ip_protocol; /* ʃvgR̎ށiUDPj */
      pseudo_header -> udp_length = text_packet -> udp_length; /* UDPZOg̒ */
      
      /* MɂUDPwb_̃`FbNŤvZ */
      sum = ones_complement_sum(header, 0, 12); /* 1̕␔ai[wb_j */
      sum += ones_complement_sum(packet, 34, (8 + 16)); /* 1̕␔aiUDPZOgj */
      sum = (sum & 0xFFFF) + (sum >> 16); /* 1̕␔a */
      sum = (~sum) & 0xFFFF; /* vZʂNOTZɂĔ] */
      if (sum != 0x0000)
      {
         return 1; /* `FbNT0x0000ɂȂȂꍇ̓G[Ƃ݂Ȃ */
      }
   }
   
   return 0; /* G[Ȃ΁C0߂lƂāCĂяo̊֐ɖ߂ */
}
