#include "H8_register.h" /* H8/3067̃WX^ */
#include "RTL8019AS_register.h" /* RTL8019AS̃WX^ */
#include "packet_definition.h" /* pPbg̒` */
#include "global_variables.h" /* O[oϐ̒` */
#include "H8_register_function.h" /* H8/3067̃WX^̐ݒ */
#include "delay_function.h" /* ԑ҂̊֐ */
#include "LCD_function.h" /* SC1602B̊֐ */
#include "NIC_function.h" /* RTL8019AS̊֐ */
#include "matrix_key_function.h" /* }gNXEL[̊֐ */
#include "utility_function.h" /* ̂ق̊֐ */
#include "ARP_function.h" /* ARP̊֐ */
#include "text_packet_function.h" /* eLXgEf[^̃pPbg̊֐ */

void main(void)
{
   unsigned short i;
   unsigned char line;
   unsigned char packet_type;
   ARP_PACKET *arp_packet;
   TEXT_PACKET *text_packet;
   
   H8_register_init(); /* H8/3067̃WX^̐ݒ */
   LCD_init(); /* SC1602B̏ */
   NIC_init(); /* RTL8019AS̏ */
   
   /* MIPAhX̐ݒ */
   src_IP[0] = 192;
   src_IP[1] = 168;
   src_IP[2] = 0;
   src_IP[3] = 100 + (P2DR & 0x07); /* fBbvEXCb`ɂđMIPAhXݒ肷 */
   
   src_port = 20000; /* M|[gԍ̐ݒ */
   
   LCD_clear(); /* \NA */
   LCD_control(0x80); /* J[\0sڂ̐擪Ɉړ */
   
   text_buffer[16] = 0x00; /* eLXgEobt@̍Ōiɂ */
   line = 0; /* linȅl */
   
   while (1) /* [v */
   {
      packet_type = 0; /* packet_type0ɂ */
      
      if (packet_receive(packet) != 1) /* pPbgMƂ */
      {
         arp_packet = (ARP_PACKET *)packet; /* packetARP_PACKET\̂ɓĂ͂߂ */
         if ((arp_packet -> eth_ethernet_type == 0x0806) && 
             /* ARP̃pPbĝƂ */
             (IP_compare(arp_packet -> arp_dst_IP, src_IP) == 0) && 
             /* pPbgɋLqĂ鈶IPAhXMIPAhXɈvƂ */
             (arp_packet -> arp_operation == 1)
             /* ARPNGXĝƂ */
            )
         {
            packet_type = 'a'; /* packet_type'a'ɂ */
         }
         
         text_packet = (TEXT_PACKET *)packet; /* packetTEXT_PACKET\̂ɓĂ͂߂ */
         if ((text_packet -> eth_ethernet_type == 0x0800) && 
             /* IP̃pPbĝƂ */
             (IP_compare(text_packet -> ip_dst_IP, src_IP) == 0) && 
             /* pPbgɋLqĂ鈶IPAhXMIPAhXɈvƂ */
             (text_packet -> ip_protocol == 17) && 
             /* UDP̃pPbĝƂ */
             (text_packet -> udp_dst_port == src_port) && 
             /* pPbgɋLqĂ鈶|[gԍM|[gԍɈvƂ */
             (text_packet_error_check(packet) != 1)
             /* pPbgɃG[ȂƂ */
            )
         {
            packet_type = 't'; /* packet_type't'ɂ */
         }
      }
      
      switch (packet_type) /* packet_typeɂďs */
      {
         case 'a': /* packet_type'a'̂Ƃ */
            ARP_reply(packet); /* ARPvC */
            break;
         case 't': /* packet_type't'̂Ƃ */
            text_packet = (TEXT_PACKET *)packet; /* packetTEXT_PACKET\̂ɓĂ͂߂ */
            for (i = 0; i < 16; i++)
            {
               text_buffer[i] = text_packet -> text_data[i];
               /* pPbgɓڂĂeLXgEf[^text_bufferɊi[ */
            }
            if (line == 0) /* line0̂Ƃ */
            {
               LCD_clear(); /* \NA */
               LCD_control(0x80); /* J[\0sڂ̐擪Ɉړ */
            }
            else if (line == 1) /* line1̂Ƃ */
            {
               LCD_control(0xC0); /* J[\1sڂ̐擪Ɉړ */
            }
            LCD_print(text_buffer); /* tfBXvCɃeLXgEobt@̕\ */
            line ^= 1; /* XORZɂāCline0̂Ƃ1Cline1̂Ƃ0ɂ */
            break;
      }
   }
}
