#include "H8_register.h" /* H8/3067̃WX^ */
#include "RTL8019AS_register.h" /* RTL8019AS̃WX^ */
#include "packet_definition.h" /* pPbg̒` */
#include "global_variables.h" /* O[oϐ̒` */
#include "H8_register_function.h" /* H8/3067̃WX^̐ݒ */
#include "delay_function.h" /* ԑ҂̊֐ */
#include "LCD_function.h" /* SC1602B̊֐ */
#include "NIC_function.h" /* RTL8019AS̊֐ */
#include "matrix_key_function.h" /* }gNXEL[̊֐ */
#include "utility_function.h" /* ̂ق̊֐ */
#include "ARP_function.h" /* ARP̊֐ */
#include "speech_packet_function.h" /* f[^̃pPbg̊֐ */
#include <machine.h> /* set_imask_ccr֐ */

/* sampling_8khz֐́C^C}荞݂ƂɌĂяo֐ */
#pragma interrupt(sampling_8khz)
void sampling_8khz(void)
{
   TISRA &= 0xFE; /* IMFA00ɖ߂ */
   
   ADCSR |= 0x20; /* ADST1ɂA-DϊX^[g */
   while ((ADCSR & 0x80) == 0x00) /* ADF1ɂȂ̂҂ */
   {
      /* A-DϊADF1ɂȂ */
   }
   ADCSR &= 0x7F; /* ADF0ɖ߂ */
   
   if (ad_buffer_flag == 0) /* ad_buffer_flag0̂Ƃ */
   {
      ad_buffer0[ad_counter] = (unsigned char)(ADDRA >> 8);
      /* ADDRȀ8bitad_buffer0Ɋi[ */
   }
   else if (ad_buffer_flag == 1) /* ad_buffer_flag1̂Ƃ */
   {
      ad_buffer1[ad_counter] = (unsigned char)(ADDRA >> 8);
      /* ADDRȀ8bitad_buffer1Ɋi[ */
   }
   
   ad_counter++; /* ad_counterCNg */
   if (ad_counter == 160) /* ad_counter160ɂȂƂ */
   {
      speech_packet_send_flag = 1;
      /* speech_packet_send_flag1ɂ */
      
      ad_buffer_flag ^= 1;
      /* XORZɂāCad_buffer_flag0̂Ƃ1Cad_buffer_flag1̂Ƃ0ɂ */
      
      ad_counter = 0;
      /* ad_counter0ɖ߂ */
   }
}

void main(void)
{
   unsigned short i;
   unsigned char packet_type;
   ARP_PACKET *arp_packet;
   
   set_imask_ccr(0); /* H8/3067荞݂󂯕tԂɂ */
   
   H8_register_init(); /* H8/3067̃WX^̐ݒ */
   LCD_init(); /* SC1602B̏ */
   NIC_init(); /* RTL8019AS̏ */
   
   /* MIPAhX̐ݒ */
   src_IP[0] = 192;
   src_IP[1] = 168;
   src_IP[2] = 0;
   src_IP[3] = 100 + (P2DR & 0x07); /* fBbvEXCb`ɂđMIPAhXݒ肷 */
   
   /* IPAhX̐ݒ */
   dst_IP[0] = 192;
   dst_IP[1] = 168;
   dst_IP[2] = 0;
   dst_IP[3] = 2;
   
   src_port = 10000; /* M|[gԍ̐ݒ */
   dst_port = 20000; /* |[gԍ̐ݒ */
   
   LCD_clear(); /* \NA */
   LCD_control(0x80); /* J[\0sڂ̐擪Ɉړ */
   
   delay_ms(2000); /* 2000msi2bj̎ԑ҂ */
   
   ARP_request(packet); /* ARPNGXg */
   
   packet_type = 0; /* packet_type0ɂ */
   do
   {
      if (packet_receive(packet) != 1) /* pPbgMƂ */
      {
         arp_packet = (ARP_PACKET *)packet; /* packetARP_PACKET\̂ɓĂ͂߂ */
         if ((arp_packet -> eth_ethernet_type == 0x0806) && 
             /* ARP̃pPbĝƂ */
             (IP_compare(arp_packet -> arp_dst_IP, src_IP) == 0) && 
             /* pPbgɋLqĂ鈶IPAhXMIPAhXɈvƂ */
             (arp_packet -> arp_operation == 2)
             /* ARPvĈƂ */
            )
         {
            for (i = 0; i < 6; i++)
            {
               dst_MAC[i] = arp_packet -> arp_src_MAC[i];
               /* pPbgɋLqĂ鑗MMACAhXdst_MACɊi[ */
            }
            packet_type = 'a'; /* packet_type'a'ɂ */
         }
      }
   } while (packet_type != 'a'); /* packet_type'a'ɂȂ܂ő҂ */
   
   src_ip_id = 0; /* src_ip_id̏l */
   speech_packet_send_flag = 0; /* speech_packet_send_flag̏l */
   ad_buffer_flag = 0; /* ad_buffer_flag̏l */
   ad_counter = 0; /* ad_counteȑl */
   
   TISRA |= 0x10; /* IMIEA01ɐݒ肵C^C}荞݂Lɂ */
   TSTR |= 0x01; /* STR01ɂă^C}0X^[g */
   
   while (1) /* [v */
   {
      if (speech_packet_send_flag == 1) /* speech_packet_send_flag1̂Ƃ */
      {
         speech_packet_send(packet); /* f[^̃pPbg𑗐M */
         src_ip_id++; /* ̃pPbĝ߂ɁCsrc_ip_idCNg */
         speech_packet_send_flag = 0; /* speech_packet_send_flag0ɖ߂ */
      }
   }
}
